#version 430



layout(location = 1) in vec3 INPUT_POSITION;
layout(location = 6) in vec3 INPUT_NORMAL;


layout(location = 2) uniform vec3 COLOR;

//camera position
layout(location = 10) uniform vec3 eye;
//((colx, coly, colz), (dirx, diry, dirz))
layout(location = 11) uniform mat2x3 directionalLight;
//((colx, coly, colz), (posx, posy, posz), (AConst, ALin, AQuadr)
layout(location = 12) uniform mat3 pointLight1;
//((colx, coly, colz), (posx, posy, posz), , (AConst, ALin, AQuadr), (dirx, diry, dirz)
layout(location = 13) uniform mat4x3 frontLight1;
layout(location = 14) uniform mat4x3 frontLight2;

layout(location = 20) uniform int textureSet;

layout(location = 31)uniform float metallic;
layout(location = 32)uniform float roughness;
layout(location = 33)uniform float ao;
layout(location = 34)uniform float reflectionFactor;

layout(location = 9) in vec2 uvs;

uniform sampler2D screenTexture;
uniform samplerCube envMap;

layout(location = 0) out vec4 fragColor;



float PI = 3.14159265359f;


void main(){

	vec3 normal = normalize(INPUT_NORMAL);
	vec3 viewDirection = normalize(eye-INPUT_POSITION);
	vec3 viewDirectionReflection = reflect(-viewDirection, normal);
	vec3 viewDirectionRefraction = refract(-viewDirection, normal, 1.33f);

	vec3 in_color;

	if(viewDirectionRefraction.x == 0 && viewDirectionRefraction.y == 0 && viewDirectionRefraction.z == 0){
		in_color = vec3(texture(envMap, viewDirectionReflection))/1;	
	}else {
		in_color = vec3(texture(envMap, viewDirectionRefraction))/1.1+vec3(texture(envMap, viewDirectionReflection))/20;	
	}


	
	
	
    fragColor = vec4(in_color, 1.0);
   }

