#version 430


layout(location = 1) in vec3 VERTEX_POSITION;
layout(location = 6) in vec3 VERTEX_NORMAL;
layout (location = 9) in vec2 UV_COORDS;
layout(location = 3) uniform mat4 VIEW_POJECTION_MATRIX;
layout(location = 4) uniform mat4 MODEL_MATRIX;
layout(location = 5) uniform mat4 ROTAION_MATRIX;

layout(location = 8) uniform float TIME;

layout(location = 1) out vec3 posWorld;
layout(location = 6) out vec3 normWorld;

layout(location = 9) out vec2 uvs;


vec3 findNormalSinWave(float x, float scale){

float a = atan(scale * cos(x));
vec3 sinWaveNormal = vec3(0,-sin(a), cos(a));

return  sinWaveNormal;

}




void main(){

	
	float x =(VERTEX_POSITION.y)/6+TIME*8;
	vec3 posAfterAnim = VERTEX_POSITION+VERTEX_NORMAL*sin(x)*3;
	posWorld = (MODEL_MATRIX * ROTAION_MATRIX *vec4(posAfterAnim, 1)).xyz;
	vec3 normAfterAnim = findNormalSinWave(x, 1);
	vec4 posCamera = VIEW_POJECTION_MATRIX  * MODEL_MATRIX * ROTAION_MATRIX * vec4(posAfterAnim, 1);
	normWorld = (transpose(inverse(MODEL_MATRIX)) * ROTAION_MATRIX * vec4(normalize(normAfterAnim),1)).xyz;
	uvs = UV_COORDS;
	
	gl_Position =  posCamera;

	
}

